(ns org.domaindrivenarchitecture.fed-poc.forge-test
  (:require
   [clojure.test :refer [deftest is are testing run-tests]]
   [clojure.spec.alpha :as s]
   [org.domaindrivenarchitecture.fed-poc.security :as sec]
   [org.domaindrivenarchitecture.fed-poc.activitystreams2 :as as]
   [org.domaindrivenarchitecture.fed-poc.forge :as sut]))

(deftest Repository-test
  (is (s/valid? ::sut/Repository
                {::as/id "https://dev.example/aviva/treesim",
                 ::as/type "Repository",
                 :sec/publicKey {::sec/id "https://dev.example/aviva/treesim#main-key",
                                 ::sec/owner "https://dev.example/aviva/treesim",
                                 ::sec/publicKeyPem "-----BEGIN PUBLIC KEY-----\nMIIBIjANBgkqhki....."}, 
                 ::sut/inbox "https://dev.example/aviva/treesim/inbox",
                 ::sut/outbox "https://dev.example/aviva/treesim/outbox",
                 ::sut/followers "https://dev.example/aviva/treesim/followers",
                 ::sut/team "https://dev.example/aviva/treesim/team",
                 ::sut/name "Tree Growth 3D Simulation",
                 ::sut/summary "<p>Tree growth 3D simulator for my nature exploration game</p>"})))