(ns org.domaindrivenarchitecture.fed-poc.core-test
  (:require
   [clojure.test :refer [deftest is are testing run-tests]]
   [clojure.spec.test.alpha :as st]
   [org.domaindrivenarchitecture.fed-poc.core :as sut]))

(st/instrument `sut/generate-like-map)

(def test-like-data
  {:object "posts/234s23-2g34234-2hhj536"
   :from "https://social.bla/alyssa/"})

(deftest produces-valid-like
  (is (= {"@context" "https://www.w3.org/ns/activitystreams",
           "id" "https://social.bla/alyssa/#likes/RANDOMHASH",
           "type" "Like",
           "actor" "https://social.bla/alyssa/",
           "object" "posts/234s23-2g34234-2hhj536"}
          (sut/generate-like-map test-like-data))))
